/**
 * COCTMT230100UVContent.java
 *
 * File generated from the medication::COCTMT230100UVContent uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.medication;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class COCTMT230100UVContent.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "COCT_MT230100UV.Content", propOrder = {
	"realmCode",
	"typeId",
	"templateId",
	"quantity",
	"containerPackagedMedicine",
	"subjectOf1",
	"subjectOf2",
	"classCode",
	"nullFlavor"
})
@XmlRootElement(name = "asContent")
public class COCTMT230100UVContent implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "realmCode", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.CS> realmCode;
	@XmlElement(name = "typeId", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.infr.AllInfrastructureRootTypeId typeId;
	@XmlElement(name = "templateId", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.infr.AllInfrastructureRootTemplateId> templateId;
	@XmlElement(name = "quantity", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.RTOQTYQTY quantity;
	@XmlElement(name = "containerPackagedMedicine", required = true, namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.COCTMT230100UVPackagedMedicine containerPackagedMedicine;
	@XmlElement(name = "subjectOf1", namespace = "urn:epsos-org:ep:medication")
	public List<net.ihe.gazelle.medication.COCTMT230100UVSubject14> subjectOf1;
	@XmlElement(name = "subjectOf2", namespace = "urn:epsos-org:ep:medication")
	public List<net.ihe.gazelle.medication.COCTMT230100UVSubject11> subjectOf2;
	@XmlAttribute(name = "classCode", required = true)
	public net.ihe.gazelle.medication.RoleClassContent classCode;
	@XmlAttribute(name = "nullFlavor")
	public net.ihe.gazelle.medication.NullFlavor nullFlavor;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return realmCode.
	 * @return realmCode
	 */
	public List<net.ihe.gazelle.datatypes.CS> getRealmCode() {
		if (realmCode == null) {
	        realmCode = new ArrayList<net.ihe.gazelle.datatypes.CS>();
	    }
	    return realmCode;
	}
	
	/**
	 * Set a value to attribute realmCode.
	 * @param realmCode.
	 */
	public void setRealmCode(List<net.ihe.gazelle.datatypes.CS> realmCode) {
	    this.realmCode = realmCode;
	}
	
	
	
	/**
	 * Add a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to add.
	 */
	public void addRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.realmCode.add(realmCode_elt);
	}
	
	/**
	 * Remove a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to remove
	 */
	public void removeRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.realmCode.remove(realmCode_elt);
	}
	
	/**
	 * Return typeId.
	 * @return typeId
	 */
	public net.ihe.gazelle.infr.AllInfrastructureRootTypeId getTypeId() {
	    return typeId;
	}
	
	/**
	 * Set a value to attribute typeId.
	 * @param typeId.
	 */
	public void setTypeId(net.ihe.gazelle.infr.AllInfrastructureRootTypeId typeId) {
	    this.typeId = typeId;
	}
	
	
	
	
	/**
	 * Return templateId.
	 * @return templateId
	 */
	public List<net.ihe.gazelle.infr.AllInfrastructureRootTemplateId> getTemplateId() {
		if (templateId == null) {
	        templateId = new ArrayList<net.ihe.gazelle.infr.AllInfrastructureRootTemplateId>();
	    }
	    return templateId;
	}
	
	/**
	 * Set a value to attribute templateId.
	 * @param templateId.
	 */
	public void setTemplateId(List<net.ihe.gazelle.infr.AllInfrastructureRootTemplateId> templateId) {
	    this.templateId = templateId;
	}
	
	
	
	/**
	 * Add a templateId to the templateId collection.
	 * @param templateId_elt Element to add.
	 */
	public void addTemplateId(net.ihe.gazelle.infr.AllInfrastructureRootTemplateId templateId_elt) {
	    this.templateId.add(templateId_elt);
	}
	
	/**
	 * Remove a templateId to the templateId collection.
	 * @param templateId_elt Element to remove
	 */
	public void removeTemplateId(net.ihe.gazelle.infr.AllInfrastructureRootTemplateId templateId_elt) {
	    this.templateId.remove(templateId_elt);
	}
	
	/**
	 * Return quantity.
	 * @return quantity
	 */
	public net.ihe.gazelle.medication.RTOQTYQTY getQuantity() {
	    return quantity;
	}
	
	/**
	 * Set a value to attribute quantity.
	 * @param quantity.
	 */
	public void setQuantity(net.ihe.gazelle.medication.RTOQTYQTY quantity) {
	    this.quantity = quantity;
	}
	
	
	
	
	/**
	 * Return containerPackagedMedicine.
	 * @return containerPackagedMedicine
	 */
	public net.ihe.gazelle.medication.COCTMT230100UVPackagedMedicine getContainerPackagedMedicine() {
	    return containerPackagedMedicine;
	}
	
	/**
	 * Set a value to attribute containerPackagedMedicine.
	 * @param containerPackagedMedicine.
	 */
	public void setContainerPackagedMedicine(net.ihe.gazelle.medication.COCTMT230100UVPackagedMedicine containerPackagedMedicine) {
	    this.containerPackagedMedicine = containerPackagedMedicine;
	}
	
	
	
	
	/**
	 * Return subjectOf1.
	 * @return subjectOf1
	 */
	public List<net.ihe.gazelle.medication.COCTMT230100UVSubject14> getSubjectOf1() {
		if (subjectOf1 == null) {
	        subjectOf1 = new ArrayList<net.ihe.gazelle.medication.COCTMT230100UVSubject14>();
	    }
	    return subjectOf1;
	}
	
	/**
	 * Set a value to attribute subjectOf1.
	 * @param subjectOf1.
	 */
	public void setSubjectOf1(List<net.ihe.gazelle.medication.COCTMT230100UVSubject14> subjectOf1) {
	    this.subjectOf1 = subjectOf1;
	}
	
	
	
	/**
	 * Add a subjectOf1 to the subjectOf1 collection.
	 * @param subjectOf1_elt Element to add.
	 */
	public void addSubjectOf1(net.ihe.gazelle.medication.COCTMT230100UVSubject14 subjectOf1_elt) {
	    this.subjectOf1.add(subjectOf1_elt);
	}
	
	/**
	 * Remove a subjectOf1 to the subjectOf1 collection.
	 * @param subjectOf1_elt Element to remove
	 */
	public void removeSubjectOf1(net.ihe.gazelle.medication.COCTMT230100UVSubject14 subjectOf1_elt) {
	    this.subjectOf1.remove(subjectOf1_elt);
	}
	
	/**
	 * Return subjectOf2.
	 * @return subjectOf2
	 */
	public List<net.ihe.gazelle.medication.COCTMT230100UVSubject11> getSubjectOf2() {
		if (subjectOf2 == null) {
	        subjectOf2 = new ArrayList<net.ihe.gazelle.medication.COCTMT230100UVSubject11>();
	    }
	    return subjectOf2;
	}
	
	/**
	 * Set a value to attribute subjectOf2.
	 * @param subjectOf2.
	 */
	public void setSubjectOf2(List<net.ihe.gazelle.medication.COCTMT230100UVSubject11> subjectOf2) {
	    this.subjectOf2 = subjectOf2;
	}
	
	
	
	/**
	 * Add a subjectOf2 to the subjectOf2 collection.
	 * @param subjectOf2_elt Element to add.
	 */
	public void addSubjectOf2(net.ihe.gazelle.medication.COCTMT230100UVSubject11 subjectOf2_elt) {
	    this.subjectOf2.add(subjectOf2_elt);
	}
	
	/**
	 * Remove a subjectOf2 to the subjectOf2 collection.
	 * @param subjectOf2_elt Element to remove
	 */
	public void removeSubjectOf2(net.ihe.gazelle.medication.COCTMT230100UVSubject11 subjectOf2_elt) {
	    this.subjectOf2.remove(subjectOf2_elt);
	}
	
	/**
	 * Return classCode.
	 * @return classCode
	 */
	public net.ihe.gazelle.medication.RoleClassContent getClassCode() {
	    return classCode;
	}
	
	/**
	 * Set a value to attribute classCode.
	 * @param classCode.
	 */
	public void setClassCode(net.ihe.gazelle.medication.RoleClassContent classCode) {
	    this.classCode = classCode;
	}
	
	
	
	
	/**
	 * Return nullFlavor.
	 * @return nullFlavor
	 */
	public net.ihe.gazelle.medication.NullFlavor getNullFlavor() {
	    return nullFlavor;
	}
	
	/**
	 * Set a value to attribute nullFlavor.
	 * @param nullFlavor.
	 */
	public void setNullFlavor(net.ihe.gazelle.medication.NullFlavor nullFlavor) {
	    this.nullFlavor = nullFlavor;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.medication");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:epsos-org:ep:medication", "asContent").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(COCTMT230100UVContent cOCTMT230100UVContent, String location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (cOCTMT230100UVContent != null){
   			cvm.validate(cOCTMT230100UVContent, location, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.CS realmCode: cOCTMT230100UVContent.getRealmCode()){
					net.ihe.gazelle.datatypes.CS.validateByModule(realmCode, location + "/realmCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.infr.AllInfrastructureRootTypeId.validateByModule(cOCTMT230100UVContent.getTypeId(), location + "/typeId", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.infr.AllInfrastructureRootTemplateId templateId: cOCTMT230100UVContent.getTemplateId()){
					net.ihe.gazelle.infr.AllInfrastructureRootTemplateId.validateByModule(templateId, location + "/templateId[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.medication.RTOQTYQTY.validateByModule(cOCTMT230100UVContent.getQuantity(), location + "/quantity", cvm, diagnostic);
			net.ihe.gazelle.medication.COCTMT230100UVPackagedMedicine.validateByModule(cOCTMT230100UVContent.getContainerPackagedMedicine(), location + "/containerPackagedMedicine", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.medication.COCTMT230100UVSubject14 subjectOf1: cOCTMT230100UVContent.getSubjectOf1()){
					net.ihe.gazelle.medication.COCTMT230100UVSubject14.validateByModule(subjectOf1, location + "/subjectOf1[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication.COCTMT230100UVSubject11 subjectOf2: cOCTMT230100UVContent.getSubjectOf2()){
					net.ihe.gazelle.medication.COCTMT230100UVSubject11.validateByModule(subjectOf2, location + "/subjectOf2[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
    	}
    }

}